//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

package com.fr.plugin.decision.api.service.consanguinity;

import com.finebi.common.api.vo.table.FineBusinessTable;
import com.finebi.dashboard.api.bean.widget.WidgetBean;
import com.finebi.dashboard.api.bean.widget.dimension.WidgetDimensionBean;
import com.finebi.dashboard.api.bean.widget.table.TableWidgetBean;
import com.finebi.widget.api.cell.WidgetCellCreator;
import com.finebi.widget.api.cell.user.FineAuthorityUser;
import com.fr.log.FineLoggerFactory;

import java.util.*;

class WidgetUsedTableFields {
    private WidgetBean widgetBean;
    private Map<String, List<String>> tableFields;
    private FineAuthorityUser user;

    public WidgetUsedTableFields(WidgetBean widgetBean, FineAuthorityUser user) {
        this.widgetBean = widgetBean;
        this.user = user;
        this.init();
    }

    public WidgetUsedTableFields(Map tableFields, FineAuthorityUser user) {
        this.tableFields = tableFields;
        this.user = user;
    }

    private void init() {
        this.tableFields = new HashMap();
        if (this.widgetBean instanceof TableWidgetBean) {
            Map<String, WidgetDimensionBean> dimensions = ((TableWidgetBean) this.widgetBean).getDimensions();
            dimensions.values().forEach((dimension) -> {
                String fieldId = dimension.getFieldId();
                try {
                    //Optional<FineBusinessTable> table = WidgetCellCreator.getCellProviderByField(fieldId).analysisTableCell().getSingleTableByFineFieldId(fieldId, this.user);
                    Optional<FineBusinessTable> table = WidgetCellCreator.getCellProviderByField(fieldId).analysisTableCell().getSingleTableWithoutFieldsWithoutAuth(fieldId);
                    if (table.isPresent()) {
                        FineBusinessTable fineBusinessTable = table.get();
                        this.addTable(fineBusinessTable.getName(), fieldId);
                    }
                } catch (Exception e) {
                    FineLoggerFactory.getLogger().error("get fieldId : {} is error ! ", fieldId);
                }
            });
        }
    }

    private void addTable(String tableName, String fieldId) {
        if (this.tableFields.containsKey(tableName)) {
            this.tableFields.get(tableName).add(fieldId);
        } else {
            List<String> fieldIds = new ArrayList();
            fieldIds.add(fieldId);
            this.tableFields.put(tableName, fieldIds);
        }
    }

    public boolean isUsedTableField(String tableName, String fieldId) {
        return this.tableFields.containsKey(tableName) && this.tableFields.get(tableName).contains(fieldId);
    }
}
